<!doctype html>
<html>
<head>
    <title>February 2008 Progress Report | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="February 2008 Progress Report | Tor Project">
    <meta property="og:description" content="Tor 0.2.0.20-rc (released Feb 24) is the first release candidate for the 0.2.0 series. It makes...">
    <meta property="og:image" content="https://blog.torproject.org/static/images/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/february-2008-progress-report/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        February 2008 Progress Report
      </h1>
    <p class="meta">by phobos | March 12, 2008</p>
    <picture>
      <source media="(min-width:415px)" srcset="../static/images/lead.webp" type="image/webp">
<source srcset="../static/images/lead_small.webp" type="image/webp">

      <img class="lead" src="../static/images/lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>Tor 0.2.0.20-rc (released Feb 24) is the first release candidate for the 0.2.0 series. It makes more progress towards normalizing Tor's TLS handshake, makes hidden services work better again, helps relays bootstrap if they don't know their IP address, adds optional support for linking in openbsd's allocator or tcmalloc, allows really fast relays to scale past 15000 sockets, and fixes a bunch of minor bugs reported by Veracode.<br />
<a href="http://archives.seul.org/or/talk/Feb-2008/msg00279.html" rel="nofollow">http://archives.seul.org/or/talk/Feb-2008/msg00279.html</a></p>

<p>Tor 0.2.0.19-alpha (released Feb 9) makes more progress towards normalizing Tor's TLS handshake, makes path selection for relays more secure and IP address guessing more robust, and generally fixes a lot of bugs in preparation for calling the 0.2.0 branch stable.<br />
<a href="http://archives.seul.org/or/talk/Feb-2008/msg00134.html" rel="nofollow">http://archives.seul.org/or/talk/Feb-2008/msg00134.html</a></p>

<p>Torbutton 1.1.13 (released Feb 1), 1.1.14 (released Feb 24), and 1.1.15 (released Feb 26) fix many more potential privacy and identity leaks, mostly based on exploits found by Greg Fleischer. They also add support for automatic updates via the usual Firefox extension upgrade approach.<br />
<a href="https://torbutton.torproject.org/dev/CHANGELOG" rel="nofollow">https://torbutton.torproject.org/dev/CHANGELOG</a></p>

<p>Work continued toward the upcoming Vidalia 0.1.0 release (which came out March 1): support for launching Firefox and Polipo as supporting applications; support for learning from Tor when the first circuit is ready so it can inform the user; and many other bugfixes including a few security fixes.<br />
<a href="http://trac.vidalia-project.net/browser/vidalia/releases/vidalia-0.1.0/CHANGELOG" rel="nofollow">http://trac.vidalia-project.net/browser/vidalia/releases/vidalia-0.1.0/…</a></p>

<p>The Tor 0.2.0.19-alpha release contained many security-related cleanups based on an anonymously submitted code review from a static analysis tool.  The Tor 0.2.0.20-rc release contained even more security-related cleanups, based on an external security analysis and audit by Veracode. Hopefully cleanups at this stage will reduce the number of times we need to push out an urgent new stable "0.2.0" release for security reasons.</p>

<p>From the Tor 0.2.0.19-alpha ChangeLog:<br />
“When connecting to a bridge without specifying its key, insert the connection into the identity-to-connection map as soon as a key is learned. This prevents the Tor user's log from showing a confusing complaint periodically.”<br />
“When our consensus networkstatus has been expired for a while, stop being willing to build circuits using it. Now clients won't give themselves away by behaving uniquely if they start up with an old networkstatus view.”</p>

<p>From the Tor 0.2.0.20-rc ChangeLog:<br />
“Choose which bridge to use proportional to its advertised bandwidth, rather than uniformly at random. This should speed up Tor for bridge users. Also do this for people who set StrictEntryNodes.”</p>

<p>From the Tor 0.2.0.19-alpha ChangeLog:<br />
“If we're a relay, avoid picking ourselves as an introduction point, a rendezvous point, or as the final hop for internal circuits.”<br />
“Directory caches now fetch certificates from all authorities listed in a networkstatus consensus, even when they do not recognize them. This bugfix is particularly important for bridge users, since the bridges are their only contact point for fetching new directory information.”</p>

<p>From the Tor 0.2.0.20-rc ChangeLog:<br />
“Servers that don't know their own IP address should go to the authorities for their first directory fetch, even if their DirPort is off or if they don't know they're reachable yet. This will help them bootstrap better.”</p>

<p>From the Tor 0.2.0.20-rc ChangeLog:<br />
“We were comparing the raw BridgePassword entry with a base64'ed version of it, when handling a "/tor/networkstatus-bridges" directory request. Now compare correctly. This bugfix should allow bridge communities (formerly known as bridge families) to work better. Noticed by Veracode.”</p>

<p>From the Tor 0.2.0.19-alpha ChangeLog:<br />
“Do not include recognizeable strings in the commonname part of Tor's x509 certificates.”</p>

<p>From the Tor 0.2.0.20-rc ChangeLog:<br />
“Enable the revised TLS handshake based on the one designed by Steven Murdoch in proposal 124, as revised in proposal 130. It includes version negotiation for OR connections as described in proposal 105. The new handshake is meant to be harder for censors to fingerprint, and it adds the ability to detect certain kinds of man-in-the-middle traffic analysis attacks. The version negotiation feature will allow us to improve Tor's link protocol more safely in the future.”</p>

<p>From the Tor 0.2.0.20-rc ChangeLog:<br />
“Tune parameters for cell pool allocation to minimize amount of RAM overhead used.”<br />
“Add OpenBSD malloc code from phk as an optional malloc replacement on Linux: some glibc libraries do very poorly with Tor's memory allocation patterns. Pass --enable-openbsd-malloc to get the replacement malloc code.”<br />
“Stop imposing an arbitrary maximum on the number of file descriptors used for extremely high-throughput servers. Bug reported by Olaf Selke; patch from Sebastian Hahn.”</p>

<p>From the Tor 0.2.0.19-alpha ChangeLog:<br />
“Patch from "Andrew S. Lists" to catch when we contact a directory mirror at IP address X and he says we look like we're coming from IP address X. This was causing some Tor relays to test their reachability by testing the wrong address, and never actually publish to the main list.”</p>

<p>We cleaned up the Tor Browser Bundle's webpage and instructions based on feedback from users who were visiting Iran and Burma. Also started preparations to make it easy for our translators to provide an alternate languages. As of March 10, we have English, German, Italian, Polish, and Russian translations. We are working to coordinate an Arabic translation too.<br />
<a href="https://torbrowser.torproject.org/" rel="nofollow">https://torbrowser.torproject.org/</a></p>

<p>The new Tor Browser Bundle 0.0.7 (released Feb 8) and 0.0.8 (released Feb 15) include security updates for Firefox (2.0.12), security updates for Torbutton (1.1.13), automate generation of internationalized bundles, allow optional extensions to be placed in build-scripts/extensions, build Polipo with regular expression support (activating the forbiddenFile option), and update Polipo configuration based on suggestions from Incognito's Polipo configuration:<br />
<a href="https://tor-svn.freehaven.net/svn/torbrowser/branches/stable/README" rel="nofollow">https://tor-svn.freehaven.net/svn/torbrowser/branches/stable/README</a></p>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/applications">
          applications
        </a>
      </li><li>
        <a href="../category/network">
          network
        </a>
      </li><li>
        <a href="../category/releases">
          releases
        </a>
      </li><li>
        <a href="../category/reports">
          reports
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-11"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-11" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>keelort (not verified)</span> said:</p>
      <p class="date-time">March 16, 2008</p>
    </div>
    <a href="#comment-11">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-11" class="permalink" rel="bookmark">torbutton 1.1.14 alpha 及以后版本(目前1.1.14-1.1.17)存在Locale switch问题</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>torbutton 1.1.14 alpha 及以后版本(目前1.1.14-1.1.17)存在Locale switch问题<br />
我使用的是英文版本的Firefox 2.0.0.12(en_US)+Locale switch，安装了zh_CN的locale，使用简体中文语言(zh_CN)的locale，但是安装了torbutton 1.1.14 alpha及以后版本，激活torbutton就会变成英文(en_US)的locale<br />
1.1.13没问题</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-14"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-14" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">March 21, 2008</p>
    </div>
    <a href="#comment-14">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-14" class="permalink" rel="bookmark">what about Firefox 3 betas support ?</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>what about Firefox 3 betas support ? , because the current stable version add-on isn't compatible with it</p>
<p>tx,</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-16"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-16" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><a rel="nofollow" href="http://ha.ckers.org/blog/20070926/de-anonymizing-tor-and-detecting-proxies/">Anonymous (not verified)</a> said:</p>
      <p class="date-time">March 24, 2008</p>
    </div>
    <a href="#comment-16">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-16" class="permalink" rel="bookmark">Tor hacked</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I found out a  post that claims  Tor can be hacked.<br />
Check it please</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-33"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-33" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  arma
  </article>
    <div class="comment-header">
      <p class="comment__submitted">arma said:</p>
      <p class="date-time">April 11, 2008</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-16" class="permalink" rel="bookmark">Tor hacked</a> by <a rel="nofollow" href="http://ha.ckers.org/blog/20070926/de-anonymizing-tor-and-detecting-proxies/">Anonymous (not verified)</a></p>
    <a href="#comment-33">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-33" class="permalink" rel="bookmark">Two answers</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>The first is to read the set of Warnings for how to use Tor safely:<br />
<a href="https://www.torproject.org/download#Warning" rel="nofollow">https://www.torproject.org/download#Warning</a></p>
<p>The second is to use the new development version of Torbutton:<br />
<a href="https://torbutton.torproject.org/dev/" rel="nofollow">https://torbutton.torproject.org/dev/</a></p>
<p>It protects against a lot of attacks, including the one you point to.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-26"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-26" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>hank (not verified)</span> said:</p>
      <p class="date-time">April 08, 2008</p>
    </div>
    <a href="#comment-26">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-26" class="permalink" rel="bookmark">Ready for ordinary people who want to be useful, or not yet?</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>OSX 10.4.11, via a Linksys router, static DSL.<br />
It appears I can use Vidalia with Firefox (torbutton works, passes tests)<br />
I can invoke Vidalia from the Dock; it runs a while then quits on its own.<br />
It says I don't have the ORport and DIRport set -- true that.</p>
<p>All I'd want to do -- I think -- is set the thing to relay but without offering any of the checkbox services, just to serve as a router within the system - the Help says that's useful.</p>
<p>Is it safe, at this level of inexpertise?  OR should I just wait?</p>
<p>Closest advice I've found online is for Linux, says:</p>
<p>[open the web page for the router]<br />
Go to the advanced tab -&gt; forwarding<br />
set up two applications, ORport, DIRport<br />
select TCP, select 9001 and 9030, and<br />
point them to whatever IP you have on your linux box.<br />
Make sure you tell TOR to advertise your external IP address via torc.</p>
<p>Well, "whatever IP" and "torc" are mysteries.<br />
--------------------</p>
<p>Doesn't quite fit the Linksys.  Maybe this should be done in the "Port Range Forwarding" section?  I have the help info.  But I wonder if I'm not smart enough to be opening the machine up like this, til it's got more assurance of security.</p>
<p>Got a "don't bother me yet trying to be helpful, we'll call you when ready" flag you can set somewhere for folks like me to know when to try to make our machines useful?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-27"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-27" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>hank (not verified)</span> said:</p>
      <p class="date-time">April 08, 2008</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-26" class="permalink" rel="bookmark">Ready for ordinary people who want to be useful, or not yet?</a> by <span>hank (not verified)</span></p>
    <a href="#comment-27">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-27" class="permalink" rel="bookmark">Oh, I did get as far as the FAQ, which in relevant part says:</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I THINK this is right -- not using the internal firewall, using the router.<br />
The FAQ for that seems to be, in full:</p>
<p>-----------begin-----</p>
<p>   * If you just use an external NAT router as your firewall, you only need to do the port forwarding through that. </p>
<p>Volunteers: please add advice for other platforms if you know how they work.</p>
<p>----------end--------</p>
<p>COMMENT:</p>
<p>I usually have just the specific IP addresses of the machines attached to the router authorized.  So I gather I'd have to add two IP addresses, and in the setup, give a 'range' of only one port number each for ORport and DIRport?</p>
<p>Here's what the Linksys BEFSR says about port forwarding.  I am open to advice whether this is what ought to be done:</p>
<p>------LINKSYS_HELP---------</p>
<p>Port Range Forwarding</p>
<p>Port Range Forwarding can be used to set up public services on your network. When users from the Internet make certain requests on your network, the Router can forward those requests to computers equipped to handle the requests. If, for example, you set the port number 80 (HTTP) to be forwarded to IP Address 192.168.1.2, then all HTTP requests from outside users will be forwarded to 192.168.1.2. It is recommended that the computer use static IP address.</p>
<p>You may use this function to establish a web server or FTP server via an IP Gateway. Be sure that you enter a valid IP address. (You may need to establish a static IP address with your ISP in order to properly run an Internet server.) For added security, Internet users will be able to communicate with the server, but they will not actually be connected. The packets will simply be forwarded through the Router.</p>
<p>To add a server using forwarding:</p>
<p>   1. Enter an Application name of the service you want to forward.<br />
   2. Enter the Port Range Start and End of the service you want to forward.<br />
   3. Select the protocol used by the services.<br />
   4. Enter the IP Address of the server that you want the Internet users to access.<br />
   5. Select Enabled for that entry.<br />
   6. Click the Save Settings button to save the settings.</p>
<p>To delete a service entry:</p>
<p>   1. Enter a zero number in the Port Range number and IP Address fields.<br />
   2. Uncheck the TCP and/or UDP check box and the Enable check box.<br />
   3. Clear the Application field.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-32"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-32" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>hank (not verified)</span> said:</p>
      <p class="date-time">April 11, 2008</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-27" class="permalink" rel="bookmark">Oh, I did get as far as the FAQ, which in relevant part says:</a> by <span>hank (not verified)</span></p>
    <a href="#comment-32">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-32" class="permalink" rel="bookmark">Anybody?</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Checking, no contact ...</p>
<p>I know you guys are busy, and since nobody's opened a new monthly thread since this February one, I may be asking in the wrong place.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div>
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
